#include "InputManager.hpp"

#include "Input.hpp"

InputManager :: InputManager()
{
}

InputManager :: ~InputManager(void)
{
	this->deleteControllers();
}

void InputManager :: registerController(Input* newController)
{
	m_controllers.push_back(newController);
}

void InputManager :: deleteControllers(void)
{
	for(std::vector<Input*>::const_iterator itController = m_controllers.begin() ; itController != m_controllers.end() ; ++itController)
	{
        delete (*itController);
	}

	m_controllers.clear();
}

InputManager::ArrowsDirection InputManager :: getDirectionsPressed()
{
	InputManager::ArrowsDirection directions = 0;

	for(std::vector<Input*>::const_iterator itController = m_controllers.begin() ; itController != m_controllers.end() ; ++itController)
	{
		directions |= (*itController)->getDirectionsPressed();
	}

	return directions;
}

InputManager::Buttons InputManager :: getButtonsPressed()
{
	int buttons = 0;

	for(std::vector<Input*>::const_iterator itController = m_controllers.begin() ; itController != m_controllers.end() ; ++itController)
	{
		buttons |= (*itController)->getButtonsState();
	}

	return buttons;
}

bool InputManager :: needEscape(void)
{
	bool escaping = false;

	for(std::vector<Input*>::const_iterator itController = m_controllers.begin() ; itController != m_controllers.end() ; ++itController)
	{
		escaping |= (*itController)->needEscape();
	}

	return escaping;
}

void InputManager :: update()
{
	for(std::vector<Input*>::const_iterator itController = m_controllers.begin() ; itController != m_controllers.end() ; ++itController)
	{
		(*itController)->update();
	}
}
