#include "GLWindow.hpp"

#include <SDL/SDL.h>
#include <GL/glew.h>

GLWindow :: GLWindow(unsigned int width, unsigned int height, const std::string& windowName, bool isFullscreen)
    :Window(width,height,windowName, isFullscreen ? SDL_OPENGL | SDL_SWSURFACE | SDL_FULLSCREEN : SDL_OPENGL | SDL_SWSURFACE)
{
    SDL_WM_SetCaption((windowName + std::string("- (OpenGL)")).c_str(),NULL);
}

void GLWindow :: clear()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
}

void GLWindow :: refresh()
{
    SDL_GL_SwapBuffers();
}
