#ifndef __WINDOW_HPP__
#define __WINDOW_HPP__

#include <exception>
#include <string>

struct SDL_Surface;

class WindowCreationException : public std::exception
{
    private:
        std::string message;

    public:
        WindowCreationException(const std::string& message):message(message) {}
        virtual ~WindowCreationException()throw() {}

        virtual const char* what() const throw()
        {
            return message.c_str();
        }
};

class Window
{
    private:

        SDL_Surface* pWindow;

    public:

        Window(unsigned int width, unsigned int height, const std::string& windowName, unsigned int sdlFlags);
        virtual ~Window();

        unsigned int getWidth()const;
        unsigned int getHeight()const;

        virtual void clear();
        virtual void resize(unsigned int width, unsigned int height);
        virtual void refresh();
};

#endif
